# Constants

Constant state used by the swap router

### State Variables <a href="#state-variables" id="state-variables"></a>

#### CONTRACT\_BALANCE <a href="#contract_balance" id="contract_balance"></a>

*Used for identifying cases when this contract's balance of a token is to be used*

```solidity
uint256 internal constant CONTRACT_BALANCE = 0;
```

#### MSG\_SENDER <a href="#msg_sender" id="msg_sender"></a>

*Used as a flag for identifying msg.sender, saves gas by sending more 0 bytes*

```solidity
address internal constant MSG_SENDER = address(1);
```

#### ADDRESS\_THIS <a href="#address_this" id="address_this"></a>

*Used as a flag for identifying address(this), saves gas by sending more 0 bytes*

```solidity
address internal constant ADDRESS_THIS = address(2);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dragonswap.app/dragonswap/resources/developer-resources/smart-contracts/dragonswapv2/smart-router/libraries/constants.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
